/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: prc_timer.c 1304 2008-08-27 07:28:36Z ertl-honda $
 */

/*
 *  J[l̃^CeBbNp^C}hCoiRenesas Starter Kit for M32C/87j
 *    ^[QbgɎgp^C}foCXقȂ蓾邱Ƃ
 *    ̃t@C^[QbgˑɔzuD
 *    ł́C^C} A0 J[l̃^CeBbNp^C}ƂĎgpD
 */
#include "kernel_impl.h"
#include "target_timer.h"
#include "time_event.h"

/*
 *  ^C}̋N
 */
void
target_timer_initialize(intptr_t exinf)
{
	uint8_t	tmp;

	tmp = sil_reb_mem((void *)TADR_TABSR);	/* ^C}JEg~  */
	tmp &= ~TBIT_TABSR_TA0S;
	sil_wrb_mem((void *)TADR_TABSR, tmp);

	sil_wrb_mem((void *)TADR_UDF, 0x00);	/* _EJEgݒ	*/
	sil_wrb_mem((void *)TADR_TA0MR, 0x00);	/*  JEg\[Xf1, ^C}[h  */

	/*
	 *  ^C} 1ms TIMER_CLOCK JEg,
	 *  WX^ݒl̓}CiX1.
	 */
	sil_wrh_mem((void *)TADR_TA0, TIMER_CLOCK - 1);

	/* JEgJn	*/
	tmp = sil_reb_mem((void *)TADR_TABSR);	/* ^C}JEg~  */
	tmp |= TBIT_TABSR_TA0S;
	sil_wrb_mem((void *)TADR_TABSR, tmp);
}

/*
 *  ^C}̒~
 */
void
target_timer_terminate(intptr_t exinf)
{
	uint8_t	tmp;

	tmp = sil_reb_mem((void *)TADR_TABSR);	/* ^C}JEg~  */
	tmp &= ~TBIT_TABSR_TA0S;
	sil_wrb_mem((void *)TADR_TABSR, tmp);
}

/*
 *  ^C}݃nh
 */
void
target_timer_handler(void)
{
	signal_time();                    /* ^CeBbN̋ */
}
