/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Platform Development Center
 *                                          RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2003-2004, 2010, 2011 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEEρE
 *  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
 *      R[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
 *      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
 *      jAȂǁjɁCL̒쌠\C̗pщL̖
 *      ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
 *      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
 *        邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
 *      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
 *  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
 *  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
 *  ȂD
 * 
 */

/*
 *	^[QbgVXeˑW[iRSK-R8C23 pj
 */

#include "kernel_impl.h"

/*
 *  ^[QbgVXeˑ [`
 */

void
target_initialize(void)
{
	uint8_t tmp;
	
	/*
	 *  vZbTˑ̏
	 */
	prc_initialize();

	/*
	 * |[g̐ݒ
	 *    |[gP66 TxD1, |[gP67 RxD1 
	 */
	tmp = sil_reb_mem((void *)TADR_PMR);
	tmp |= TBIT_PMR_U1PINSEL;
	sil_wrb_mem((void *)TADR_PMR, tmp);

	tmp = sil_reb_mem((void *)TADR_PD6);
	tmp &= ~TBIT_BIT7;
	tmp |= TBIT_BIT6;
	sil_wrb_mem((void *)TADR_PD6, tmp);

	/* |[gݒ(샂[hAʐMx) */
	sil_wrb_mem((void *)(TADR_UART1_BASE+TADR_UMR_OFFSET), MR_DEF);
	sil_wrb_mem((void *)(TADR_UART1_BASE+TADR_UC0_OFFSET), C0_DEF);
	sil_wrb_mem((void *)(TADR_UART1_BASE+TADR_UBRG_OFFSET), BRG1_DEF);
}


/*
 *  ^[QbgVXȅI[`
 */

void
target_exit(void)
{
	/* CPUˑ̏I[` */
	prc_terminate();
	
	while (1)
		;
}

/*
 * VXeO̒჌xo͂̂߂̕o
 */
void target_fput_log(char_t c)
{
	if (c == '\n') {
		sys_putc('\r', SIO_PORTID);
	}
	sys_putc(c, SIO_PORTID);
}
