/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 *  VAI/OfoCXiSIOjhCoiRenesas Starter Kit for R8C/23pj
 */

#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H

#include "rsk_r8c23.h"
#include "target_syssvc.h"

/*
 *  VAI/O|[g SFR x[XAhX
 */
#define	TADR_UART0_BASE     0x0a0			/* uart0WX^x[XAhX */
#define	TADR_UART1_BASE     0x0a8			/* uart1WX^x[XAhX */

/*
 *  x[XAhX̃ItZbg
 */
#define	TADR_UMR_OFFSET     0			/* M[hWX^ */
#define	TADR_UBRG_OFFSET    1			/* rbg[gWX^ */
#define	TADR_UTB_OFFSET     2			/* Mobt@WX^ */
#define	TADR_UC0_OFFSET     4			/* M䃌WX^#0 */
#define	TADR_UC1_OFFSET     5			/* M䃌WX^#1 */
#define	TADR_URB_OFFSET     6			/* Mobt@WX^ */

/*
 *  M䃌WX^1 (UiC1, i=0,1) ̃rbg`
 */
#define	TBIT_UiC1_RI	TBIT_BIT3	/* MtO */
#define	TBIT_UiC1_RE	TBIT_BIT2	/* Mrbg */
#define	TBIT_UiC1_TI	TBIT_BIT1	/* Mobt@tO */
#define	TBIT_UiC1_TE	TBIT_BIT0	/* Mrbg */

/*
 *  foCXI[ṽgCJEg
 *  @500񃊃gC΁A\ɏID
 */
#define	SFRUART_COUNT	500

/*
 * VARg[WX^̐ݒl 
 */
#define	MR_DEF        	0x05	/* NbNA񓯊A8rbgApeBȂAX[vȂ */
#define MR_DISABLE_DEF	0x00	/* VAW[ */

#define	C0_DEF		0x10	/* JEg\[Xf1 */
#define	C1_DEF		0x00	/* VAM֎~, Mݗv́uMobt@v */

#if BPS_SETTING==38400
#define	BRG1_DEF	32	/* 20000000/{(UxBRG+1)*16} = 38400 */
#elif BPS_SETTING==19200
#define	BRG2_DEF	64	/* 20000000/{(UxBRG+1)*16} = 19200 */
#endif

/*
 *  e|[gɑΉ銄ݔԍCDx
 */
/* |[g1 */
// ݔԍ
#define INTNO_SIOP1_SND	INTNO_S1T
#define INTNO_SIOP1_RCV	INTNO_S1R
// ݗDx
#define INTPRI_SIOP1_SND	(-2)	
#define INTPRI_SIOP1_RCV	(-3)
// ݗvC
#define INTATR_SIOP1_RCV  	(0)
#define INTATR_SIOP1_SND  	(0)

/*
 *  R[obN[`̎ʔԍ
 */
#define SIO_RDY_SND    1U        /* M\R[obN */
#define SIO_RDY_RCV    2U        /* MʒmR[obN */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  VAI/O|[gǗubN̒`
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  SIO
 */
extern void sio_initialize(intptr_t exinf);

/*
 *  VAI[v
 */
extern SIOPCB *sio_opn_por(ID siopid, intptr_t exinf);

/*
 *  VAN[Y
 */
extern void sio_cls_por(SIOPCB *p_siopcb);

/*
 *  ݃T[rX[`
 */
extern void sio_isr_rcv(intptr_t exinf);
extern void sio_isr_snd(intptr_t exinf);

/*
 *  1M
 */
extern bool_t sio_snd_chr(SIOPCB *siopcb, char_t c);

/*
 *  1M
 */
extern int_t sio_rcv_chr(SIOPCB *siopcb);

/*
 *  R[obN̋
 */
extern void sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/* 
 *  R[obN̋֎~
 */
extern void sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  M\R[obN
 */
extern void sio_irdy_snd(intptr_t exinf);

/*
 *  MʒmR[obN
 */
extern void sio_irdy_rcv(intptr_t exinf);

/*
 *  1Mi|[Oł̏ój
 */
extern void sio_pol_snd_chr(char_t c, ID siopid);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_SERIAL_H */
