/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: prc_timer.c 1304 2008-08-27 07:28:36Z ertl-honda $
 */

/*
 *  J[l̃^CeBbNp^C}hCoiRenesas Starter Kit for R8C/23j
 *    ^[QbgɎgp^C}foCXقȂ蓾邱Ƃ
 *    ̃t@C^[QbgˑɔzuD
 *    ł́C^C} RA J[l̃^CeBbNp^C}ƂĎgpD
 */
#include "kernel_impl.h"
#include "target_timer.h"
#include "time_event.h"

/*
 *  ^C}̋N
 */
void
target_timer_initialize(intptr_t exinf)
{
	uint8_t	tmp;

	tmp = sil_reb_mem((void *)TADR_TRACR);	/* ^C}JEg~  */
	tmp &= ~TBIT_TRACR_TSTART;
	sil_wrb_mem((void *)TADR_TRACR, tmp);

	sil_wrb_mem((void *)TADR_TRAMR, 0x00);	/*  JEg\[Xf1, ^C}[h  */
	sil_wrb_mem((void *)TADR_TRAIOC, 0x00);	/* P1_7  INT1/TRAIO [q */
	sil_wrb_mem((void *)TADR_TRAPRE, 80-1);	/* 50[ns] * 80 = 4[us]  TRA JEg  */
	sil_wrb_mem((void *)TADR_TRA, 250-1);	/* 4[us] * 250 = 1[ms] Ƀ^C} */

	tmp = sil_reb_mem((void *)TADR_TRACR);	/* JEgJn  */
	tmp |= TBIT_TRACR_TSTART;
	sil_wrb_mem((void *)TADR_TRACR, tmp);
}

/*
 *  ^C}̒~
 */
void
target_timer_terminate(intptr_t exinf)
{
	uint8_t	tmp;

	tmp = sil_reb_mem((void *)TADR_TRACR);	/* ^C}JEg~  */
	tmp &= ~TBIT_TRACR_TSTART;
	sil_wrb_mem((void *)TADR_TRACR, tmp);
}

/*
 *  ^C}݃nh
 */
void
target_timer_handler(void)
{
	signal_time();                    /* ^CeBbN̋ */
}
